# mkwbd3.awk

# from CostCentreManagerList_20160426.csv
#Org Program Name,CCMgrName,CostCentre,,,,,
#Alfred Foundation,"Mihelcic, Angela",Y2004 Alfred Foundation General,,,,,
#,,Y2006 TAF - Donor Recognition,,,,,
#,,Y2141 Donor Acquisition Program,,,,,
#,,Y4003 Father's Day Appeal,,,,,


function trim(s)
{
	sub(/^[ \t]*/,"",s)
	sub(/[ \t]*$/,"",s)
	gsub(/\,/,";",s)
	gsub(/\\/,"",s)
	return s
}

function rmspace(s)
{
        gsub(/ /,"",s)
        gsub(/\//,"-",s)
        gsub(/['"]/, "", s)
        return s
}

function clip(s)
{
        sub(/[ \t]*$/,"",s)
        gsub(/\//,"-",s)
        gsub(/['"]/, "", s)
        return s
}


function fxt21name(s)
{
	gsub(/\'/,"",s)
	return s
}

#-------------------------------------------------------------



function ld_t21dircsvfile(t21dircsvfile) {
	printf("ld_t21dircsvfile(%s)\n", t21dircsvfile)
	system("date")

	# test 3032,ZVARGULIS,MARIS,8685,MATHS RW

	#dt.recordno, dc.surname, dc.firstname, dt.extension, dc.title,
	# dc.location, dt.extgroupunique, dc.email,
	# dc.faxno, dc.telephone,
	# dc.division_college, dc.department_school

	t21dirreccnt = -1
	while ( (getline aline < t21dircsvfile) > 0 ) {
		++t21dirreccnt
		split(aline, a_arr, ",")
		#printf("aline=%s\n", aline)
		#printf("a_arr 1=%s 2=%s 3=%s 4=%s 5=%s\n", a_arr[1], a_arr[2], a_arr[3], a_arr[4], a_arr[5])
		f = 0
		recordno = trim(a_arr[++f])
		t21surname = trim(a_arr[++f])
		t21firstname = trim(a_arr[++f])
		extension = trim(a_arr[++f])
		department = trim(a_arr[++f])
		telephone = trim(a_arr[++f])
		speeddial = trim(a_arr[++f])
		intpagerno = trim(a_arr[++f])
		faxno = trim(a_arr[++f])
		t21location = trim(a_arr[++f])
		sitenm1 = trim(a_arr[++f])
		fulltitle = trim(a_arr[++f])
		position = trim(a_arr[++f])
		grname3 = trim(a_arr[++f])
		email = trim(a_arr[++f])
		title = trim(a_arr[++f])
		empid = trim(a_arr[++f])
		extgroupunique = trim(a_arr[++f])
		Mobile = trim(a_arr[++f])
		CarrierCode = trim(a_arr[++f])
		master = trim(a_arr[++f])
		hdate = trim(a_arr[++f])

		extn = extension

		t21campus = ""
		if ( recordno != "RecordNo" )
			t21campus = substr(sitenm1,6)

		#print "   t21campus = [" t21campus "]"

		# for mk_dircsvfile()
		#print " recordno = [" recordno "]"
		recordno_to_aline_arr[recordno] = aline
		#print "   recordno_to_aline_arr[" recordno "] = [" recordno_to_aline_arr[recordno] "]"

		t21dirreccnt_to_recordno_arr[t21dirreccnt] = recordno
		#print "   t21dirreccnt_to_recordno_arr[" t21dirreccnt "] = [" t21dirreccnt_to_recordno_arr[t21dirreccnt] "]"

		if ( t21dirreccnt <= 0 )
			continue	# skip header

		recordno_to_master_arr[recordno] = master
		#print "   recordno_to_master_arr[" recordno "] = [" recordno_to_master_arr[recordno] "]"


		if ( t21surname == "" )
			t21surname = "_blank_"
		if ( t21firstname == "" )
			t21firstname = "_blank_"

		if ( t21campus == "" )
			t21campus = "_blank_"

		if ( t21location == "" )
			t21location = "_blank_"

		if ( t21division_college == "" )
			t21division_college = "_blank_"

		if ( t21department_school == "" )
			t21department_school = "_blank_"

		gsub(" ","",t21mobile)
		gsub("-","",t21mobile)

		#printf(" - extgroupunique = [%s]  extn = [%s]\n", extgroupunique, extn)
		#printf("   t21surname = [%s]  t21firstname = [%s]\n", t21surname, t21firstname)
		#printf("   t21campus = [%s]  t21location = [%s]\n", t21campus, t21location)
		#printf("   t21division_college  = [%s]\n", t21division_college)


		#printf("   t21department_school = [%s]\n", t21department_school)

		t21name = t21surname
		if ( t21firstname != "_blank_")
			t21name = sprintf("%s %s", t21firstname, t21name)
		recordno_to_t21name_arr[recordno] = t21name
		#print "      recordno_to_t21name_arr[" recordno "] = [" recordno_to_t21name_arr[recordno] "]"

		if ( t21name_to_recordno_arr[t21name] != "" ) {
			print "Warning: ld_t21dir duplicte t21name=[" t21name "]"
		}
		else {
			t21name_to_recordno_arr[t21name] = recordno
			print "    t21name_to_recordno_arr[" t21name "]=[" t21name_to_recordno_arr[t21name] "]"
		}

		# rjs 17/11/2014
		##recordno_to_staffid_arr[recordno] = staffid
		#recordno_to_staffid_arr[recordno] = recordno
		recordno_to_staffid_arr[recordno] = email
		#print "      recordno_to_staffid_arr[" recordno "] = [" recordno_to_staffid_arr[recordno] "]"

		recordno_to_extn_arr[recordno] = extn
		recordno_to_eggrid_arr[recordno] = extgroupunique
		recordno_to_t21campus_arr[recordno] = t21campus
		recordno_to_t21location_arr[recordno] = t21location

		recordno_to_t21surname_arr[recordno] = t21surname
		recordno_to_t21firstname_arr[recordno] = t21firstname
		recordno_to_t21division_college_arr[recordno] = t21division_college
		recordno_to_t21department_school_arr[recordno] = t21department_school

		#print "      recordno_to_extn_arr[" recordno "] = [" recordno_to_extn_arr[recordno] "]"
		#print "      recordno_to_eggrid_arr[" recordno "] = [" recordno_to_eggrid_arr[recordno] "]"

		#itag = extgroupunique "|" extn
		itag = extn
		#printf(" itag = [%s]\n", itag)

		if ( master == "Y" ) {
			if ( dirextn_to_recordno_arr[itag] == "" )
				dirextn_to_recordno_arr[itag] = recordno
			if ( dirextn_to_t21name_arr[itag] == "" )
				dirextn_to_t21name_arr[itag] = t21name
			if ( dirextn_to_t21name_arr[itag] != t21name )
				dirextn_to_t21name_arr[itag] = "Multiple"
			#print "    dirextn_to_t21name_arr[" itag "] = [" dirextn_to_t21name_arr[itag] "]"

			if ( dirextn_to_t21surname_arr[itag] == "" )
				dirextn_to_t21surname_arr[itag] = t21surname
			if ( dirextn_to_t21surname_arr[itag] != t21surname )
				dirextn_to_t21surname_arr[itag] = "Multiple"

			if ( dirextn_to_t21firstname_arr[itag] == "" )
				dirextn_to_t21firstname_arr[itag] = t21firstname
			if ( dirextn_to_t21firstname_arr[itag] != t21firstname )
				dirextn_to_t21firstname_arr[itag] = "Multiple"

			#print "  before dirextn_to_t21campus_arr[" itag "]=[" dirextn_to_t21campus_arr[itag] "]"
			if ( dirextn_to_t21campus_arr[itag] == "" )
				dirextn_to_t21campus_arr[itag] = t21campus
			if ( dirextn_to_t21campus_arr[itag] != t21campus )
				dirextn_to_t21campus_arr[itag] = "Multiple"

			#print "  after dirextn_to_t21campus_arr[" itag "]=[" dirextn_to_t21campus_arr[itag] "]"
			if ( dirextn_to_t21location_arr[itag] == "" )
				dirextn_to_t21location_arr[itag] = t21location
			if ( dirextn_to_t21location_arr[itag] != t21location )
				dirextn_to_t21location_arr[itag] = "Multiple"

			if ( dirextn_to_t21division_college_arr[itag] == "" )
				dirextn_to_t21division_college_arr[itag] = t21division_college
			if ( dirextn_to_t21division_college_arr[itag] != t21division_college )
				dirextn_to_t21division_college_arr[itag] = "Multiple"

			if ( dirextn_to_t21department_school_arr[itag] == "" )
				dirextn_to_t21department_school_arr[itag] = t21department_school
			if ( dirextn_to_t21department_school_arr[itag] != t21department_school )
				dirextn_to_t21department_school_arr[itag] = "Multiple"
			dirextn_to_eggrid_arr[itag] = extgroupunique
		}

		if ( egrid_to_t21campus_arr[extgroupunique] == "" )
			egrid_to_t21campus_arr[extgroupunique] = t21campus
		if ( egrid_to_t21campus_arr[extgroupunique] != t21campus )
			egrid_to_t21campus_arr[extgroupunique] = "Multiple"

		if ( have_extn_egrid_arr[extn "|" extgroupunique] == "" ) {
			if ( extn_to_egridlist_arr[extn] == "" )
				extn_to_egridlist_arr[extn] = extgroupunique
			else
				extn_to_egridlist_arr[extn] = extn_to_egridlist_arr[extn] "|" extgroupunique
			have_extn_egrid_arr[extn "|" extgroupunique] = "1"
		}
		#print " extn_to_egridlist_arr[" extn "] = [" extn_to_egridlist_arr[extn] "]"

		if ( t21surname == ".INDIAL" ) {
			indial_nbr = gsub("X","[0-9]",telephone)
			indial_arr[telephone] = t21campus
			#print " indial_arr[" telephone "] = [" indial_arr[telephone] "]"
		}

	}
	close(t21dircsvfile)
}



function ld_t21groups3(t21groups3file) {
	printf("ld_t21groups3(%s)\n", t21groups3file)
	system("date")
	while ( (getline aline < t21groups3file) > 0 ) {
		split(aline, a_arr, "|")
		##printf("aline=%s\n", aline)
		#printf("a_arr 1=%s 2=%s 3=%s 4=%s\n", a_arr[1], a_arr[2], a_arr[3], a_arr[4])
		parentgroupid = clip(a_arr[1])
		grid = clip(a_arr[2])
		grtype = clip(a_arr[3])
		grname1 = clip(a_arr[4])
		grname2 = clip(a_arr[5])
		grname3 = clip(a_arr[6])

		if ( parentgroupid == "" )
			parentgroupid = "NOPAR"

		printf(" - parentgroupid = [%s]  grid = [%s]  grtype = [%s]", parentgroupid, grid, grtype)
		printf("   grname1 = [%s]  grname2 = [%s]  grname3 = [%s]\n", grname1, grname2, grname3)

		parentchild_arr[parentgroupid "|" grid] = 1

		childcount_arr[parentgroupid] += 1

		grid_to_parentgroupid_arr[grid] = parentgroupid
		grid_to_grtype_arr[grid] = grtype
		grid_to_grname1_arr[grid] = grname1
		CCP = grname1
		centre_dot_project = 0

		## default CENTRE/PROJECT to grname1/00000
		##CENTRE = grname1
		##PROJECT = "00000"
		#CENTRE = parentgroupid
		#PROJECT = grid
		CENTRE = grid
		PROJECT = ""

		# UWS.....
		#if ( length(grname1) >= 11 && (substr(grname1,6,1) == "-" || substr(grname1,6,1) == ".") ) {		
		#	CENTRE = sprintf("%05d", substr(grname1,1,5))
		#	PROJECT = sprintf("%05d", substr(grname1,7,5))
		#	CCP = CENTRE "." PROJECT
		#	centre_dot_project = 1
		#}
		## old test for tenant
		##if ( length(grname1) == 4 ) {	# 4 digit Tenant
		##	CENTRE = sprintf("%04d", substr(CCP,1,4))
		##	PROJECT = "00000"
		##}
		##if ( length(grname1) == 5 ) {	# 5 digit Tenant
		##	CENTRE = sprintf("%05d", substr(CCP,1,5))
		##	PROJECT = "00000"
		##}
		##if ( length(grname1) == 6 ) {	# 56digit Tenant
		##	CENTRE = sprintf("%06d", substr(CCP,1,6))
		##	PROJECT = "00000"
		##}
		#
		## now check for pargrid
		#if ( parentgroupid == "TENANTS" ) {
		#	is_TENANT_arr[grid] = 1
		#}
		# ...UWS


		## ECU...
                ## ECU on UNI-CC groups grname1...
                ## PPPPPPP-CCC-AA-LL-NNNN
                ## 0010000-001-AA-07-9645
                #if ( grtype == "E" ) {
                ##if ( grtype == "E" && length(grname1) >= 16 && substr(grname1,8,1) == "-" && substr(grname1,12,1) == "-" && substr(grname1,15,1) == "-" ) {

                ##       #CENTRE = sprintf("%05d", substr(grname1,9,3))
                ##       #PROJECT = sprintf("%05d", substr(grname1,1,7))
                #        CENTRE = parentgroupid
                #        PROJECT = grid
                #        CCP = grname1
                #        centre_dot_project = 1
                #        print "ld_t21groups() is centre_dot_project"
                #}

		# Alfred (flat hierarchy, ie: all egrid under BAYSIDE ggrid)...
                if ( grtype == "E" ) {
                        CENTRE = grid
                        PROJECT = "-"
                        CCP = grname1
                        centre_dot_project = 1
                	#print "ld_t21groups() is centre_dot_project"
                        is_TENANT_arr[grid] = 0
                }

		printf("              CENTRE = [%s]  PROJECT = [%s]\n", CENTRE, PROJECT)

		#if ( grtype == "G" || !centre_dot_project ) {
		# Afred flat
		if ( grtype == "E" ) {
			#if ( centre_dot_project )
				CENTRE = grid		# always use grid
			CENTREdesc = grname3
			CENTREdesc1 = grname1
			CENTREdesc2 = grname2
			CENTREdesc3 = grname3
                        if ( CENTREdesc == "" )
                                CENTREdesc = grname2
                        if ( CENTREdesc == "" )
                                CENTREdesc = grid
			CENTRE_to_CENTREdesc_arr[CENTRE] = CENTREdesc
			CENTRE_to_CENTREdesc1_arr[CENTRE] = CENTREdesc1
			#CENTRE_to_CENTREdesc2_arr[CENTRE] = CENTREdesc2
			CENTRE_to_CENTREdesc3_arr[CENTRE] = CENTREdesc3

			print "CENTRE_to_CENTREdesc_arr[" CENTRE "] = " CENTRE_to_CENTREdesc_arr[CENTRE]
		}

		if ( grtype == "E" ) {
			#PROJECTdesc = grname3
                        #if ( PROJECTdesc == "" )
                        #        PROJECTdesc = grname2
                        #if ( PROJECTdesc == "" )
                        #        PROJECTdesc = grid
			PROJECTdesc = grname3
			PROJECTdesc1 = grname1
			PROJECTdesc2 = grname2
			PROJECTdesc3 = grname3

			CENTREPROJECT_to_PROJECTdesc_arr[CENTRE "|" PROJECT] = PROJECTdesc
			CENTREPROJECT_to_PROJECTdesc1_arr[CENTRE "|" PROJECT] = PROJECTdesc1
			CENTREPROJECT_to_PROJECTdesc2_arr[CENTRE "|" PROJECT] = PROJECTdesc2
			CENTREPROJECT_to_PROJECTdesc3_arr[CENTRE "|" PROJECT] = PROJECTdesc3

			print "CENTREPROJECT_to_PROJECTdesc_arr[" CENTRE "|" PROJECT "] = " CENTREPROJECT_to_PROJECTdesc_arr[CENTRE "|" PROJECT]

			CENTRE_to_GGRID_arr[CENTRE] = parentgroupid
			print "CENTRE_to_GGRID_arr[" CENTRE "] = " CENTRE_to_GGRID_arr[CENTRE]
			CENTREPROJECT_to_EGRID_arr[CENTRE "|" PROJECT] = grid
			print "CENTREPROJECT_to_EGRID_arr[" CENTRE "|" PROJECT "] = " CENTREPROJECT_to_EGRID_arr[CENTRE "|" PROJECT]

			is_CENTRE_dot_PROJECT_arr[grid] = centre_dot_project
		}

		grid_to_ccp_arr[grid] = CCP
		grid_to_centre_arr[grid] = CENTRE
		grid_to_project_arr[grid] = PROJECT
		grid_to_grname2_arr[grid] = grname2
		grid_to_grname3_arr[grid] = grname3

                print "grid_to_centre_arr[" grid "]  = [" grid_to_centre_arr[grid] "]"
	}
	close(t21groups3file)

	# create entry for Unallocated Mobiles
	desc = "Unallocated Mobiles"
	grid = "UN_MOB"
	parentgroupid = "MISC"		#"UNALLOC"
	CENTRE = parentgroupid
	PROJECT = grid
	grid_to_grtype_arr[grid] = "E"
	grid_to_centre_arr[grid] = CENTRE
	grid_to_project_arr[grid] = PROJECT
	grid_to_ccp_arr[grid] = desc
	grid_to_grname1_arr[grid] = desc
	grid_to_grname2_arr[grid] = desc
	grid_to_grname3_arr[grid] = desc
	grid_to_parentgroupid_arr[grid] = parentgroupid
	#CENTRE_to_CENTREdesc_arr[CENTRE] = desc
	#CENTRE_to_CENTREdesc1_arr[CENTRE] = desc
	#CENTRE_to_CENTREdesc2_arr[CENTRE] = desc
	#CENTRE_to_CENTREdesc3_arr[CENTRE] = desc
	CENTREPROJECT_to_PROJECTdesc_arr[CENTRE "|" PROJECT] = desc
	CENTREPROJECT_to_PROJECTdesc1_arr[CENTRE "|" PROJECT] = desc
	CENTREPROJECT_to_PROJECTdesc2_arr[CENTRE "|" PROJECT] = desc
	CENTREPROJECT_to_PROJECTdesc3_arr[CENTRE "|" PROJECT] = desc
	CENTRE_to_GGRID_arr[CENTRE] = parentgroupid
	CENTREPROJECT_to_EGRID_arr[CENTRE "|" PROJECT] = grid
	is_CENTRE_dot_PROJECT_arr[grid] = 0
	is_TENANT_arr[grid] = 0
}


#-------------------------------------------------------------------


function handle_name(Name, distgrid)
{
	split(Name, name_arr, ";")
	t21surname = fxt21name(trim(toupper(name_arr[1])))
	t21firstname = fxt21name(trim(toupper(name_arr[2])))

	t21name = t21surname
	if ( t21firstname != "_blank_")
		t21name = sprintf("%s %s", t21firstname, t21name)
	print "   t21name_to_recordno_arr[" t21name "]=[" t21name_to_recordno_arr[t21name]"]"
	DirectoryID = t21name_to_recordno_arr[t21name]
	if ( DirectoryID == "" ) {
		errmsg = "Error: can't get telmax21 DirectoryID for t21name=[" t21name "]"
		print errmsg
		print errmsg | "sort -u >mkwbd3.badName"
		return
	}

	thisdistid = DirectoryID_to_distid_arr[DirectoryID]
	if ( thisdistid == "" ) {
		# create new distid
		#thisdistid = DirectoryID
		thisdistid = nextdistid++
		DirectoryID_to_distid_arr[DirectoryID] = thisdistid
		print "Creating NEW distid=[" thisdistid "]  for t21name=[" t21name "]"
	}

	print "    adding distgrid=[" distgrid "] to distid=[" thisdistid "]"
	print ""

	if ( done_distid_wbdconf_arr[thisdistid] == "" ) {
		# create wbdconf entry
		recordno = DirectoryID
		distid  = thisdistid
		distiddesc = "Reports for " t21name
		lastdist = ""
		lastdistdate = ""
		altemail = ""
		altemailyn = "N"
		wbd_method = "WEB"
		wbd_type = "STANDARD"
		userid = ""
		passwd = ""
		sdate = "01/10/2015"		# StartDate
		edate = ""

		print recordno "|" distid  "|" distiddesc "|" lastdist "|" lastdistdate "|" altemail "|" altemailyn "|" wbd_method "|" wbd_type "|" userid "|" passwd "|" sdate "|" edate "|" >> wbdconffile

		done_distid_wbdconf_arr[thisdistid] = "1"
	}

	if ( grid_to_centre_arr[distgrid] == "" ) {
		errmsg = "Error: distgrid=[" distgrid  "] does not exist in telmax21 hierarchy"
		print errmsg
		print errmsg | "sort -u >mkwbd3.badCC"
		return
	}

	print "    t21name=[" t21name "] DirectoryID=[" DirectoryID "] "
	# create wbdlist entry1
	distid = thisdistid
	grid = distgrid

	if ( done_distidgrid_arr[ distid "|" grid ] == "1" ) {
		print "Warning: t21name=[" t21name "] DirectoryID [" DirectoryID "]" "  already has grid [" grid "]"
		return
	}

	done_distidgrid_arr[ distid "|" grid ] = "1"

	print distid "|" grid "|" >> wbdlistfile

}


#-------------------------------------------------------------------

BEGIN {
        #dbid0 = start_database("catcom")
        ##print "dbid0 = " dbid0

	#load_Directory()

	ld_t21dircsvfile(t21dircsvfile)
	ld_t21groups3(t21groups3file)

	nextdistid = startdistid
}

{
	print ""
	print "--------------------------------------------------"
	print "NR=" NR ": " $0
	print ""
	if ( NR == 1 )	# skip header
		next
	f = 0
	Org_Program_Name = trim($(++f))
	Cost_Centre_Manager = trim($(++f))
	Cost_Centre = trim($(++f))

	print "  Org_Program_Name=[" Org_Program_Name "]"
	print "  Cost_Centre_Manager=[" Cost_Centre_Manager "]"
	print "  Cost_Centre=[" Cost_Centre "]"

	if ( Org_Program_Name == "" )
		Org_Program_Name = LAST_Org_Program_Name
	if ( Cost_Centre_Manager == "" )
		Cost_Centre_Manager = LAST_Cost_Centre_Manager


	split(Cost_Centre, CostCentre_arr, " ")
	CostCentreCode =  CostCentre_arr[1]
	print "  CostCentreCode=[" CostCentreCode "]"

	if ( CostCentreCode != "" ) {
		distgrid = CostCentreCode

		handle_name(Cost_Centre_Manager, distgrid)
	}
	else {
		print "Error: blank Cost Centre Code [" $0 "]"
	}

	LAST_Org_Program_Name = Org_Program_Name
	LAST_Cost_Centre_Manager = Cost_Centre_Manager
}

